rpm: String Manipulation API.

rpm 4.19.1.1 The RPM Package Manager

Loading...
Searching...
No Matches
Files | Functions
String Manipulation API.
Data types:

String Manipulation API. More...

Collaboration diagram for String Manipulation API.:

## Files
file | rpmstring.h

## Functions
RPM_GNUC_PURE int | rstrcasecmp (const char *s1, const char *s2)
RPM_GNUC_PURE int | rstrncasecmp (const char *s1, const char *s2, size_t n)
int | rasprintf (char **strp, const char *fmt,...) RPM_GNUC_PRINTF(2
int int | rvasprintf (char **strp, const char *fmt, va_list ap)
char * | rstrcat (char **dest, const char *src)
char * | rstrscat (char **dest, const char *arg,...) RPM_GNUC_NULL_TERMINATED
size_t | rstrlcpy (char *dest, const char *src, size_t n)
RPM_GNUC_PURE unsigned int | rstrhash (const char *string)
char * | rpmhex (const uint8_t *p, size_t plen)

## Detailed Description

String Manipulation API.

## Function Documentation

## ◆ rasprintf()

int rasprintf | ( | char ** | strp,
|  | const char * | fmt,
|  |  | ...
| ) |  |

asprintf() clone

## ◆ rpmhex()

char * rpmhex | ( | const uint8_t * | p,
|  | size_t | plen
| ) |  |

Return hex formatted representation of bytes.

Parameters

  p | bytes
  plen | no. of bytes

Returns
  hex formatted string (malloc'ed)

## ◆ rstrcasecmp()

RPM_GNUC_PURE int rstrcasecmp | ( | const char * | s1,
|  | const char * | s2
| ) |  |

Locale insensitive strcasecmp(3).

## ◆ rstrcat()

char * rstrcat | ( | char ** | dest,
|  | const char * | src
| ) |  |

Concatenate two strings with dynamically (re)allocated memory.

Parameters

  dest | pointer to destination string
  src | source string

Returns
  realloc'd dest with src appended

## ◆ rstrhash()

RPM_GNUC_PURE unsigned int rstrhash | ( | const char * | string | ) |

String hashing function

Parameters

  string | string to hash

Returns
  hash id

## ◆ rstrlcpy()

size_t rstrlcpy | ( | char * | dest,
|  | const char * | src,
|  | size_t | n
| ) |  |

strlcpy() clone: Copy src to string dest of size n. At most n-1 characters will be copied. Always zero-terminates (unless n == 0). Length of src is returned; if retval >= n, truncation occurred.

Parameters

  dest | destination buffer
  src | string to copy
  n | destination buffer size

Returns
  length of src string

## ◆ rstrncasecmp()

RPM_GNUC_PURE int rstrncasecmp | ( | const char * | s1,
|  | const char * | s2,
|  | size_t | n
| ) |  |

Locale insensitive strncasecmp(3).

## ◆ rstrscat()

char * rstrscat | ( | char ** | dest,
|  | const char * | arg,
|  |  | ...
| ) |  |

Concatenate multiple strings with dynamically (re)allocated memory.

Parameters

  dest | pointer to destination string
  arg | NULL terminated list of strings to concatenate

Returns
  realloc'd dest with strings appended

## ◆ rvasprintf()

int int rvasprintf | ( | char ** | strp,
|  | const char * | fmt,
|  | va_list | ap
| ) |  |

vasprintf() clone